<?php

namespace AppBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\JsonResponse;
use AppBundle\Entity\Film;
use AppBundle\Form\FilmType;

class VideothequeController extends Controller
{
	/**
	 * @Route("/", name="racine_test")
	 */
	public function indexAction()
	{
	    
		return $this->render('@App/videotheque/testajax.html.twig', array(
			'villes'	=> "Test"
		));
	}

	/**
	 * @Route("/liste", name="videotheque_liste")
	 */
	public function listeAction()
	{
		$em = $this->getDoctrine()->getManager();
		$repo = $em->getRepository('AppBundle:Film');
		$listeFilms = $repo->findAll();

		return $this->render('@App/videotheque/liste.html.twig', array(
			'listeFilms'	=>	$listeFilms
		));
	}	

	/**
	 * @Route("/ajouter", name="videotheque_ajouter")
	 */
	public function ajouterAction(Request $request)
	{
		$film = new Film;
		$form = $this->createForm(FilmType::class, $film);

		$form->handleRequest($request);
		if ($form->isSubmitted() && $form->isValid())
		{
			$film = $form->getData();
			$em = $this->getDoctrine()->getManager();
			$em->persist($film);
			$em->flush();
			$this->addFlash('success', 'Le film a été ajouté');
			return $this->redirectToRoute('videotheque_liste');
		}



		return $this->render('@App/videotheque/ajouter.html.twig', array(
			'form'	=>	$form->createView(),
			'film'	=>	$film
		));
	}

	/**
	 * @Route("/modifier/{id}", name="videotheque_modifier")
	 */
	public function modifierAction(Request $request, $id)
	{
		$em = $this->getDoctrine()->getManager();
		$repo = $em->getRepository('AppBundle:Film');
		$film = $repo->find($id);
		$form = $this->createForm(FilmType::class, $film);
		$form->handleRequest($request);

		if ($form->isSubmitted() && $form->isValid())
		{
			$film = $form->getData();
			$em = $this->getDoctrine()->getManager();
			$em->flush();
			$this->addFlash('success', 'Le film a été modifié');
			return $this->redirectToRoute('videotheque_liste');
		}


		return $this->render('@App/videotheque/modifier.html.twig', array(
			'form'	=> $form->createView()
		));
	}

	/**
	 * @Route("/supprimer/{id}", name="videotheque_supprimer")
	 */
	public function supprimerAction($id)
	{
		return $this->render('@App/videotheque/supprimer.html.twig', array(
			// ...
		));
	}

    /**
	 * @Route("/rqajax", name="videotheque_requete_ajax")
	 */
	public function requeteAjaxAction(Request $request)
	{	    
        $em = $this->getDoctrine()->getManager();
        $repo = $em->getRepository('AppBundle:Realisateur');
        $resultats = $repo->findByNom($request->request->get('mot_cle'));
	    if ($request->isXmlHttpRequest())
	    {
	        foreach ($resultats as $key=>$realisateur) {
    	        $resultats[$key] = $this->get('serializer')->serialize($realisateur, 'json');
    	    }
	        return new JsonResponse($resultats);
    	}
    	return $this->render ('@App/videotheque/testajax.html.twig', array (
    	    'realisateurs' => $resultats
	    ));
	}	    

}
